#include<bits/stdc++.h>
using namespace std;
int n,m,dp[100004],q[100004];
vector<int> adj[100004];
int solve(int vr){
    if(dp[vr]!=0){
        return dp[vr];
    }
    else if((int)adj[vr].size()==0){
        return 0;
    }
    else{
        for(int j=0;j<(int)adj[vr].size();j++){
            dp[vr]+=1+solve(adj[vr][j]);
        }
    }
    return dp[vr];
}
int main(){
ios_base::sync_with_stdio(false);
cin.tie(NULL);
cout.tie(NULL);
memset(dp,0,sizeof(dp));
cin>>n;
for(int i=0;i<n-1;i++){
    int u,v;
    cin>>u>>v;
    adj[u].push_back(v);
}
cin>>m;
for(int i=0;i<m;i++){
    cin>>q[i];
}
for(int i=0;i<m;i++){
    cout<<solve(q[i])<<endl;
}
return 0;
}
